package com.zipcodewilmington.arrayutility;

import java.lang.reflect.Array;
import java.util.ArrayList;
import java.util.Arrays;

/**
 * Created by leon on 3/6/18.
 */
public class ArrayUtility<T> {
    private T[] inputArray;


    public ArrayUtility(T[] inputArray) {
        this.inputArray = inputArray;
    }

    public T[] merge(T[] input) {
        T[] combined = (T[]) new Object[inputArray.length + input.length];
        System.arraycopy(inputArray, 0, combined, 0, inputArray.length);
        System.arraycopy(input, 0, combined, inputArray.length, input.length);
        return combined;
    }

    public Integer countDuplicatesInMerge(T[] arrayToMerge, T valueToEvaluate) {

        T[] combined = merge(arrayToMerge);


        int count = 0;
        for (T e : combined) {
            if (e == valueToEvaluate) {
                count++;
            }
        }
        return count;
    }


    public T getMostCommonFromMerge(T[] arrayToMerge) {
        T[] combined = merge(arrayToMerge);
        int count = 1, tempCount;
        T popular = combined[0];
        T temp;
        for (int i = 0; i < (combined.length - 1); i++)
        {
            temp = combined[i];
            tempCount = 0;
            for (int j = 1; j < combined.length; j++)
            {
                if (temp == combined[j])
                    tempCount++;
            }
            if (tempCount > count)
            {
                popular = temp;
                count = tempCount;
            }
        }
        return popular;
    }

    public Integer getNumberOfOccurrences(T valueToEvaluate) {
        Integer count = 0;
        for(T e : inputArray){
            if(e == valueToEvaluate){
                count++;
            }
        }
        return count;
    }

    public T[] removeValue(T valueToRemove) {
        int occ = getNumberOfOccurrences(valueToRemove);
        T[] answer = (T[]) Array.newInstance(inputArray.getClass().getComponentType(), inputArray.length-occ);
        int count=0;
        for(int i = 0; i < inputArray.length; i++){
            if(!inputArray[i].equals(valueToRemove)){
                answer[count] = inputArray[i];
                count++;
            }
        }
        return answer;
    }
}
